package com.planetes;

import java.util.*;

class astroList{

	public float gravity;
	public Vector<astro> planets;

	public astroList(int n){
		gravity = (float)1e-2;
		planets = new Vector<astro>();
		for (int i = 0 ; i < n ; i++)
			planets.addElement(new astro()); 
	}

    public astroList(astroList arg){
    	gravity = arg.gravity;
        planets = new Vector<astro>();
    	for(int i = 0 ; i < arg.planets.size() ; i++)
            planets.addElement(arg.planets.get(i));
    }
    
    public int size(){
    	return planets.size();
    }

	protected void merge(){
		for( int i = 0 ; i < planets.size() ; i++){
			for (int j = i + 1 ; j < planets.size() ; j++){
				if( ( planets.get(i).pos.sub(planets.get(j).pos)).mod() < planets.get(i).rad + planets.get(j).rad ){
					float mi = planets.get(i).mass;
					float mj = planets.get(j).mass;
					planets.get(i).pos._add(planets.get(i).pos.multiply(mi/(mi+mj)).add( planets.get(j).pos.multiply(mj/(mi+mj))));
					planets.get(i).speed._add(planets.get(i).speed.multiply(mi/(mi+mj)).add( planets.get(j).speed.multiply(mj/(mi+mj))));
					planets.get(i).color._add(planets.get(i).color.multiply(mi/(mi+mj)).add( planets.get(j).color.multiply(mj/(mi+mj))));
					planets.get(i).rad = (float) Math.cbrt(mi+mj);
					planets.remove(j);
				}
			}
		}
	}

    public void Add(astro arg){
        planets.addElement(arg);
    }

    public void Move(){
        merge();
        astroList clone = new astroList(this);
        for(int i = 0 ; i < planets.size() ; i++){
            planets.get(i).tail.addElement(planets.get(i).pos);
        	for(int j = 0 ; j < planets.size() ; j++){
                if(i!=j){
                    point r = new point(clone.planets.get(j).pos.sub(clone.planets.get(i).pos));
                    planets.get(i).speed._add(r.multiply(gravity*planets.get(j).mass/(r.mod()*r.mod()*r.mod())));
                }
                planets.get(i).pos._add(planets.get(i).speed);
            }
        }
        merge();
    }

}
